// -*- Mode:C++ -*-
//Header:
//File: astable.h
//Title: Association Table
//Author: NODA Itsuki
//Date: 1998/3/28
//EndHeader:

//ModifyHistory:
// 1998/3/28: Create this file
//EndModifyHistory:

//Memo:
//EndMemo:

#ifndef _astableT_h_
#define _astableT_h_
////////////////////////////////////////////////////////////////////////
#include "gbtype.h"
#include "gstream.h"
#include "mmtoolT.h"

//======================================================================
// ASTable<KeyType,ContentType>
//

template <class _KeyType_, class _ContentType_>
class ASTable {
  public:
   typedef ASTable<_KeyType_, _ContentType_> astable_t ;
   typedef _KeyType_ key_t ;
   typedef _ContentType_ cont_t ;
   class as_entry_t {
      public:
	 key_t key ;
	 cont_t value ;

	 inline as_entry_t() {} ;
	 inline as_entry_t(key_t k, cont_t v) {
	    key = k ; value = v ;
	 } ; 
	 inline friend gostream& operator<< (gostream& o, const as_entry_t& e) 
	 {
	    o << "#e[" << e.key << ":" << e.value << "]" ;
	    return o ;
	 } ;
   } ;

   AStack<as_entry_t> table ;

   inline Int push(key_t k, cont_t v) {
      table.push(as_entry_t(k,v)) ;
      return table._top ;
   } ;

   inline cont_t find(key_t k, cont_t not_found) {
      for(Int i = 0 ; i < table._top ; i++) {
	 if(eq(k,table.table[i].key)) return table.table[i].value ; 
      }
      return not_found ;
   } ;

   inline UInt toppos() { return table._top ; } ;

   inline cont_t& operator[] (UInt i) const {
      return table[i].value ;
   } ;

} ;

////////////////////////////////////////////////////////////////////////
#endif

