// -*- Mode:C++ -*-
//Header:
//File: gbtype.h
//Author: NODA Itsuki
//Date: 1998/2/6
//EndHeader:

//Note:
// gbtype.h : general basic data type
//  [types]
//	Int
//	UInt
//	ID 
//	Float
//	Bool
//
//  [constant]
//	True, False
//	NULLPTR
//	NULLCHAR
//
//  [functions]
//	isNullPtr
//EndNote:

#ifndef _gbtype_h_
#define _gbtype_h_
////////////////////////////////////////////////////////////////////////

#ifdef NULL
#undef NULL
#define NULL 0
#endif

//======================================================================
// Number Data Typedef
//
typedef long Int ;
typedef unsigned long UInt ;
typedef double Float ;
typedef unsigned int ID ;
#ifdef Linux
typedef bool Bool ;
#define True true
#define False false
#else
typedef int Bool ;
#define True 1
#define False 0
#endif

/*#define NULLPTR	(void *)0*/
/*#define NULLPTR NULL*/
#define NULLPTR 0
#define NULLCHAR '\000'

inline Bool isNullPtr(const void* ptr) { return ptr == NULLPTR ; } ;
inline Bool isNullChar(const char c) { return c == NULLCHAR ; } ;

////////////////////////////////////////////////////////////////////////
#endif /* _gbtype_h_ */
