#include "gdata.h"
#include "gcell.h"
#include "gem.h"
GaeaData NullSymbol ;
GaeaData AnonymousVar ;
GaeaData ErrorSymbol ;
GaeaData EOFSymbol ;
GaeaData YesSymbol ;
GaeaData NoSymbol ;
GaeaData ForceSymbol ;
GaeaData UserNeverUseSymbol ;
GaeaData RuleOpSymbol ;
GaeaData FactOpSymbol ;
GaeaData TrueSymbol ;
GaeaData FailSymbol ;
GaeaData FalseSymbol ;
GaeaData AndSymbol ;
GaeaData OrSymbol ;
GaeaData CutSymbol ;
GaeaData GenSymSeedSymbol ;
GaeaData DLHandleSymbol ;
GaeaData FileReadModeSymbol ;
GaeaData FileWriteModeSymbol ;
GaeaData FileAppendModeSymbol ;
GaeaData FileReadWriteModeSymbol ;
ExtObjTypeID EOT_IOStream ;
GaeaData SpecialCharSymbol_Newline ;
GaeaData SpecialCharSymbol_Tab ;
GaeaData SpecialCharSymbol_Space ;
GaeaData ConsSymbol ;
GaeaData ConsCarVar ;
GaeaData ConsCdrVar ;
GaeaData ConsTerm ;
GaeaCell* BasicCell ;
GaeaCell* MainCell ;
ExtObjTypeID EOT_Barrier ;
GaeaData TimeOutSymbol ;
int Argc ;
char** Argv ;
GaeaData RoleSymbol ;
GaeaData RoleRoleVar ;
GaeaData RoleValueVar ;
GaeaData RoleTermVar ;
GaeaData RoleTerm3 ;
ExtObjTypeID EOT_Buffer ;
GaeaData ReaderVarPackSymbol ;
GaeaData ReaderVarPackArg ;
GaeaData ReaderVarPackTerm ;

void gglobalInit() {
    NullSymbol = GaeaSymbol("$") ;
    AnonymousVar = GaeaVariable("_") ;
    ErrorSymbol = GaeaSymbol("$error") ;
    EOFSymbol = GaeaSymbol("$eof") ;
    YesSymbol = GaeaSymbol("yes") ;
    NoSymbol = GaeaSymbol("no") ;
    ForceSymbol = GaeaSymbol("force") ;
    UserNeverUseSymbol = GaeaSymbol("$user_never_use$") ;
    RuleOpSymbol = GaeaSymbol("$rule") ;
    FactOpSymbol = GaeaSymbol("$fact") ;
    TrueSymbol = GaeaSymbol("$true") ;
    FailSymbol = GaeaSymbol("$fail") ;
    FalseSymbol = GaeaSymbol("$false") ;
    AndSymbol = GaeaSymbol("$and") ;
    OrSymbol = GaeaSymbol("$or") ;
    CutSymbol = GaeaSymbol("$cut") ;
    GenSymSeedSymbol = GaeaSymbol("$g") ; ;
    DLHandleSymbol = GaeaSymbol("$dlhandle") ;
    DLoad(NULLPTR,NULLPTR,DLHandleSymbol) ;
    FileReadModeSymbol = GaeaSymbol("read") ;
    FileWriteModeSymbol = GaeaSymbol("write") ;
    FileAppendModeSymbol = GaeaSymbol("append") ;
    FileReadWriteModeSymbol = GaeaSymbol("read_write") ;
    EOT_IOStream = DefExtObjType("iostream") ;
    SpecialCharSymbol_Newline = GaeaSymbol("newline") ;
    SpecialCharSymbol_Tab = GaeaSymbol("tab") ;
    SpecialCharSymbol_Space = GaeaSymbol("space") ;
    ConsSymbol = GaeaSymbol("$") ;
    ConsCarVar = GaeaVariable("_CAR") ;
    ConsCdrVar = GaeaVariable("_CDR") ;
    ConsTerm = GaeaTerm(ConsSymbol,ConsCarVar,ConsCdrVar) ;
    BasicCell = new GaeaCell(GaeaSymbol("basic")) ;
    BasicCell->hiddenInListingp = True ;
    MainCell = new GaeaCell(GaeaSymbol("main")) ;
    GemHeapTab = new GemHeap(GEMHEAP_NAME,GemHeapTabSize,GemHeapTabFactor) ;
    EOT_Barrier = DefExtObjType("barrier") ;
    TimeOutSymbol = GaeaSymbol("timeout") ;
    randomize_by_ctime()  ;
    Argc = 0 ;
    Argv = (char**)NULLPTR ;
    RoleSymbol = GaeaSymbol("$role") ;
    RoleRoleVar = GaeaVariable("_ROLE") ;
    RoleValueVar = GaeaVariable("_VALUE") ;
    RoleTermVar = GaeaVariable("_TERM") ;
    RoleTerm3 = GaeaTerm(RoleSymbol,RoleRoleVar,RoleValueVar,RoleTermVar) ;
    EOT_Buffer = DefExtObjType("buffer") ;
    ReaderVarPackSymbol = GaeaSymbol("var") ;
    ReaderVarPackArg = GaeaVariable("_$") ;
    ReaderVarPackTerm = GaeaTerm(ReaderVarPackSymbol,ReaderVarPackArg) ;

} ;
