#ifndef _REENTRANT
#define _REENTRANT
#endif

#include "gstream.h"

void
gostream::odispatch (void (ostream::*func) ())
{
  if (os)
    {
      lock ();
      (os->*func) ();
      unlock ();
    }
}

void
gostream::odispatch (ostream & (ostream::*func) ())
{
  if (os)
    {
      lock ();
      (os->*func) ();
      unlock ();
    }
}

int
gostream::odispatch (int (ostream::*func) ())
{
  int ret = 0;
  if (os)
    {
      lock ();
      ret = (os->*func) ();
      unlock ();
    }
  return ret;
}

void
gistream::idispatch (void (istream::*func) ())
{
  if (is)
    {
      lock ();
      (is->*func) ();
      unlock ();
    }
}

void
gistream::idispatch (istream & (istream::*func) ())
{
  if (is)
    {
      lock ();
      (is->*func) ();
      unlock ();
    }
}

int
gistream::idispatch (int (istream::*func) ())
{
  int ret = 0;
  if (is)
    {
      lock ();
      ret = (is->*func) ();
      unlock ();
    }
  return ret;
}

int
gistream::idispatch (unsigned int (istream::*func) ())
{
  int ret = 0;
  if (is)
    {
      lock ();
      ret = (is->*func) ();
      unlock ();
    }
  return ret;
}

// Predefined streams.
gifstream gin (0);
gofstream gout (1);
gofstream gerr (2);
