#! /usr/local/bin/perl

($infile) = @ARGV ;

($basename) = ($infile =~ /^(.*)\.tab$/) ;
$ccfile = $basename.".cc" ;
$hfile = $basename.".h" ;

$headerflagname = "_".$hfile."_" ;
$headerflagname =~ tr/\./_/ ;

open(IN,$infile) ;
open(CCOUT,">$ccfile") ;
open(HOUT,">$hfile") ;

printf HOUT '#ifndef %s
#define %s
////////////////////////////////////////////////////////////////////////

',$headerflagname,$headerflagname ;

# printf CCOUT '#include "%s"
# 
# ',$hfile ;

while(<IN>) {
    /^##/ && do { s/^##/#/ ; print CCOUT ; next ;} ;
    /^#/ && do { print HOUT ; next ;} ;
    /^\s*$/ && do {print HOUT ; next;} ;
    
    if(/^\@decl/) {
	($op,$type,$var,@init) = split ;
	$init = join(' ',@init) ;
	printf HOUT "extern %s %s ;\n",$type,$var ;
	printf CCOUT "%s %s ;\n",$type,$var ;
	$dummy = sprintf("    %s = %s ;\n",$var,$init) ;
	push(@olist,$dummy) ;
    } elsif (/^\@set/) {
	($op,$var,@init) = split ;
	$init = join(' ',@init) ;
	$dummy = sprintf("    %s = %s ;\n",$var,$init) ;
	push(@olist,$dummy) ;
    } elsif (/^\@call/) {
	($op,$form) = /^([^\s]+)\s+(.*)$/ ;
	$dummy = sprintf("    %s ;\n",$form) ;
	push(@olist,$dummy) ;
    }
}

printf CCOUT '
void %sInit() {
', $basename ;

foreach $_ (@olist) {
    print CCOUT $_ ;
} ;

printf CCOUT '
} ;
' ;

printf HOUT '
extern void %sInit() ;

////////////////////////////////////////////////////////////////////////
#endif
',$basename;

close(HOUT) ;
close(CCOUT) ;
close(IN);
