%%%
%
% for demonstration
%
%	% cgaea -e demo1.g
%	?- cycle.
%	[nakashima_san,ha,imasu,ka].
%	?- cycle.
%	[tomorrow,ha,kimasu,ka].
%	?- cycle.
%	[kore,wo,watasu,onegai].
%







newcell(parse).
push(parse).

$rule(parse1([Var,ha | Tail],Tail,$(|person(Var)@ga),
      	    topic(Var,$role(_,person(Var),_))),
      person(Var)).

$rule(parse1([Var,ni,ha | Tail],Tail,$(|place(Var)@ni_place),
      	    topic(Var,$role(_,place(Var),_))),
      place(Var)).

$rule(parse1([Var,ha | Tail],Tail,$(|time(Var)@ni_time),
      	    topic(Var,$role(_,time(Var),_))),
      time(Var)).
$rule(parse1([Var,wo | Tail],Tail,$(|object(Var)@object),_),
      $true).

$rule(parse1([imasu | Tail],Tail,$(|exist@verb),_),true).
$rule(parse1([kimasu | Tail],Tail,$(|come@verb),_),true).
$rule(parse1([watasu | Tail],Tail,$(|give@verb),_),true).

$rule(parse1([ka | Tail],Tail,$(|query@mode),_),true).
$rule(parse1([onegai | Tail],Tail,$(|ask@mode),_),true).

$rule(parse(Sentense,Frame,Topic),parse(Sentense,[],Frame,Topic)).
$rule(parse(Tail,Tail,Frame,Topic),$true).
$rule(parse(Head,Tail,Frame,Topic),
	$and(	parse1(Head,Mid,Frame,Topic),
		parse(Mid,Tail,Frame,Topic))).

$fact(person(nakashima_san)).
$fact(person(me)).
$fact(place(here)).
$fact(time(now)).
$fact(time(tomorrow)).

$rule(generate(sentense,Head,Tail,Frame),
	$and(	$eq(Frame,$(|Var@mode)),$var(Var),!,
		generate(subj,Head,Mid1,Frame),
		generate(vp,Mid1,Mid2,Frame),
		generate(aux,Mid2,Tail,Frame))).
$rule(generate(sentense,[please|Head],Tail,Frame),
	$and(	$eq(Frame,$(|ask@mode)),!,
		generate(vp,Head,Mid2,Frame),
		generate(aux,Mid2,Tail,Frame))).
$rule(generate(sentense,['?'|Head],Tail,Frame),
	$and(	$eq(Frame,$(|query@mode)),!,
		generate(subj,Head,Mid1,Frame),
		generate(vp,Mid1,Mid2,Frame),
		generate(aux,Mid2,Tail,Frame))).
$rule(generate(subj,[Person | Tail],Tail,$(|person(Person)@ga)), $true).
$rule(generate(vp,Head,Tail,Frame),
	$and(	generate(vi,Head,Tail,Frame))).
$rule(generate(vp,Head,Tail,Frame),
	$and(	generate(vt2,Head,Mid1,Frame),
		generate(obj,Mid1,Mid2,Frame),
		generate(dest,Mid2,Tail,Frame))).

$rule(generate(vi,[exist|Tail],Tail,$(|exist@verb)),$true).
$rule(generate(vi,[come|Tail],Tail,$(|come@verb)),$true).
$rule(generate(vt2,[give|Tail],Tail,$(|give@verb)),$true).
$rule(generate(obj,[Obj|Tail],Tail,$(|Obj@object)),$true).
$rule(generate(dest,[to,Dest|Tail],Tail,$(|person(Dest)@ni_dest)),
	person(Dest)).

$rule(generate(aux,Head,Tail,Frame),
	$and(	generate(aux_time,Head,Mid1,Frame),
		generate(aux_place,Mid1,Tail,Frame))).

$rule(generate(aux_time,[Time|Tail],Tail,$(|time(Time)@ni_time)),$true).
$rule(generate(aux_place,[at,Place|Tail],Tail,$(|place(Place)@ni_place)),$true).

$rule(cycle,
	$and(	$write_special_char('Input: '),
		$read(Sentense),
		parse(Sentense,Frame,Topic),
		$nl,$write(Frame),$nl,
		generate(sentense,ESent,[],Frame),
		$nl,$write(ESent),$nl,
		gentopic(Topic),
		!)).

$rule(demo,
	$and(	$repeat,
		$environment(Env),$write(current_env(Env)),$nl,
		cycle,
		$environment1([Top | _]),
		$nl,$listing(Top),$nl,
		fail)).

$rule(gentopic(Var),$and($var(Var),!)).
$rule(gentopic(topic(Name,Role)),
	$and(	newcell(Name),
		push(Name),
		aa(Role))).

$fact($role(_,person(me),_)).
$fact($role(_,place(here),_)).
$fact($role(_,time(now),_)).



	