$newcell($lgaea).
push($lgaea).

$rule(call(Goal),Goal).

$rule(true,$true).
% $rule(true(),$true).

$rule(fail,$fail).
% $rule(fail(),$fail).

$rule(for(Var,Init,Max,Step),$for(Var,Init,Max,Step)).
$rule(for(Var,Init,Max,Step,Goal),$for(Var,Init,Max,Step,Goal)).

$rule(repeat,$repeat).
$rule(break,$halt).

$rule(lt(X,Y),$comp_lt(X,Y)).
$rule(le(X,Y),$comp_le(X,Y)).
$rule(gt(X,Y),$comp_gt(X,Y)).
$rule(ge(X,Y),$comp_ge(X,Y)).

$fact(unify(X,X)).

$rule(open(Stream,Filename,Mode),$fopen(Stream,Filename,Mode)).
$rule(close(Stream,Mode),$fclose(Stream,Mode)).

$rule($new_cellvar_lg(Cell,[CellVar,InitVal]),
	$and(!,$new_cellvar(Cell,CellVar,InitVal))).
$rule($new_cellvar_lg(Cell,CellVar),
	$and(!,$new_cellvar(Cell,CellVar))).

$rule(new_cell(Cell),
	$newcell(Cell)).
$rule(new_cell(Cell,Var),
	$and($newcell(Cell),$new_cellvar_lg(Cell,Var))).
$rule(new_cell(Cell,Var1,Var2),
	$and($newcell(Cell),
		$new_cellvar_lg(Cell,Var1),
		$new_cellvar_lg(Cell,Var2))).
$rule(new_cell(Cell,Var1,Var2,Var3),
	$and($newcell(Cell),
		$new_cellvar_lg(Cell,Var1),
		$new_cellvar_lg(Cell,Var2),
		$new_cellvar_lg(Cell,Var3))).
$rule(new_cell(Cell,Var1,Var2,Var3,Var4),
	$and($newcell(Cell),
		$new_cellvar_lg(Cell,Var1),
		$new_cellvar_lg(Cell,Var2),
		$new_cellvar_lg(Cell,Var3),
		$new_cellvar_lg(Cell,Var4))).

$rule(cell_exist(Cell),$cell_exist(Cell)).

$rule(get_load_path(Path),$loadpath(Path)).
$rule(set_load_path([]),$clearloadpath).
$rule(set_load_path($(Path,Rest)),
	$and(set_load_path(Rest),!,
		$addloadpath(Path))).

$rule(push_load_path(Path),$addloadpath(Path)).
$rule(pop_load_path(Path),$delloadpath(Path)).

$rule(cons(Car,Cdr,Cons),
	unify(Cons,$(Car,Cdr))).

$rule(var(V),$var(V)).
$rule(nonvar(V),$nonvar(V)).
$rule(neq(X,Y),not(eq(X,Y))).

$rule(ls,$system("ls")).
$rule(ls(Opt1),$system("ls",Opt1)).	
$rule(ls(Opt1,Opt2),$system("ls",Opt1,Opt2)).	
$rule(ls(Opt1,Opt2,Opt3),$system("ls",Opt1,Opt2,Opt3)).	
$rule(ls(Opt1,Opt2,Opt3,Opt4),$system("ls",Opt1,Opt2,Opt3,Opt4)).	

$rule(ed,$system("mule")).
$rule(ed(Opt1),$system("mule",Opt1)).	
$rule(ed(Opt1,Opt2),$system("mule",Opt1,Opt2)).	
$rule(ed(Opt1,Opt2,Opt3),$system("mule",Opt1,Opt2,Opt3)).	
$rule(ed(Opt1,Opt2,Opt3,Opt4),$system("mule",Opt1,Opt2,Opt3,Opt4)).	

$rule(cat(Opt1),$system("cat",Opt1)).	
$rule(cat(Opt1,Opt2),$system("cat",Opt1,Opt2)).	
$rule(cat(Opt1,Opt2,Opt3),$system("cat",Opt1,Opt2,Opt3)).	
$rule(cat(Opt1,Opt2,Opt3,Opt4),$system("cat",Opt1,Opt2,Opt3,Opt4)).	

$rule(more(Opt1),$system("more",Opt1)).	
$rule(more(Opt1,Opt2),$system("more",Opt1,Opt2)).	
$rule(more(Opt1,Opt2,Opt3),$system("more",Opt1,Opt2,Opt3)).	
$rule(more(Opt1,Opt2,Opt3,Opt4),$system("more",Opt1,Opt2,Opt3,Opt4)).	

$rule(csh,$system("csh")).
$rule(tcsh,$system("tcsh")).

$rule(cwd(X),$cwd(X)).
$rule(pwd,$and($cwd(X),$write(X),$nl)).

$rule(fpush(Cell),$and($cell_exist(Cell),!,$push(Cell))).
$rule(fpush(Cell),$and($newcell(Cell),$push(Cell))).
$rule(fpush(Cell,Dest),$and($cell_exist(Cell),!,$push(Cell,Dest))).
$rule(fpush(Cell,Dest),$and($newcell(Cell),$push(Cell,Dest))).

$rule(needs(Cell),$and($in_env_recursive(Cell),!)).
$rule(needs(Cell),$and(!,$push(Cell))).
$rule(needs(Cell,Dest),$and($in_env_recursive(Cell,Dest),!)).
$rule(needs(Cell,Dest),$and(!,$push(Cell,Dest))).

$rule(functor(Term,Functor,Arity),$term_arity(Term,Functor,Arity)).
$rule(tab(N),$for(I,0,N,1,$write_special_char(space))).

$rule(list_to_term(List,Term),
	$and(	$eq(List,$(Head,Argv)),
		length(Argv,Arity),
		$genterm(Head,Arity,Term),
		list_to_term_sub(Term,Argv,0))).
$rule(list_to_term_sub(Term,[],_),$true).
$rule(list_to_term_sub(Term,$(Arg,Rest),Argc),
	$and(	$let_term_argv(Term,Argc,Arg),
		$inc(Argc,Argc1),
		list_to_term_sub(Term,Rest,Argc1))).

$rule(term_to_list(Term,$(Head,Argv)),
	$and(	$term_arity(Term,Head,Arity),
		term_to_list_sub(Term,0,Arity,Argv))).
$rule(term_to_list_sub(Term,Arity,Arity,[]),!).
$rule(term_to_list_sub(Term,N,Arity,$(Arg,Rest)),
	$and(	$term_argv(Term,N,Arg),
		$inc(N,N1),
		term_to_list_sub(Term,N1,Arity,Rest))).

$rule(number(X),$isnumber(X)).
$rule(atom(X),$isatom(X)).
$rule(listing_var(CELL),$cv_listing(Cell)).



pop($lgaea).
