%%======================================================================
%% test signal
%%----------------------------------------------------------------------

$newcell(test_signal).
$push(test_signal).

$rule(foo_x(Name,SigList),
	$and(	$wait_signal(Sig,SigList),
		$write(wakeup(Name,Sig,SigList)),$nl)).

$rule(foo1,
	$and(	$fork(foo_x(foo1,[a,b,c]),_),
		$fork(foo_x(foo2,[a,c,d]),_),
		$fork(foo_x(foo3,[a,b,d,x]),_))).

$rule(show_waitlist(Signal),
	$and(	$signal_wait_list(Signal,List),
		$write(w(Signal,List)),
		$cut)).
$rule(show_waitlist_all,
	$and(	$msleep(10),
		show_waitlist(a),
		show_waitlist(b),
		show_waitlist(c),
		show_waitlist(d),
		show_waitlist(x),
		show_waiting_signal_all,
		$nl)).

$rule(show_waiting_signal(Gem),
	$and(	$waiting_signal(Gem,List),
		$write(g(Gem,List)),
		$cut)).

$rule(show_waiting_signal_all,
		$and(	show_waiting_signal(gem_1),
			show_waiting_signal(gem_2),
			show_waiting_signal(gem_3))).

$rule(foo,
	$and(	foo1,
		show_waitlist_all,
		$sleep(2),
		$signal(c),
		show_waitlist_all,
		$sleep(1),
		$signal(b),
		show_waitlist_all,
		$sleep(1),
		$signal(x),
		show_waitlist_all)).

$rule(bar_x(Name,SigList,S),
	$and(	$timedwait_signal(Sig,SigList,S),
		$write(wakeup(Name,Sig,SigList)),$nl)).

$rule(bar1,
	$and(	$fork(bar_x(bar1,[a,b,c],1),_),
		$fork(bar_x(bar2,[a,c,d],2),_),
		$fork(bar_x(bar3,[a,b,d,x],2),_))).

$rule(bar,
	$and(	bar1,
		show_waitlist_all,$sleep(1),
		$signal(c),
		show_waitlist_all,$sleep(1),
		$signal(b),
		show_waitlist_all,$sleep(1),
		$signal(x),
		show_waitlist_all)).

$pop(_).
%%======================================================================
%% test barriers
%%----------------------------------------------------------------------


$newcell(test_barrier).
$push(test_barrier).

$rule(foo1,
	$and(	b(B),
		$dotimes(I,10),
		$fork($and($barrier_wait(B),$write(end(I)),$nl),_),
		$fail)).
$rule(foo1,$true).

$rule(foo,
	$and(	$newbarrier(B),
		as(b(B)),
		foo1,
		sleep(3),
		$barrier_signal(B))).

$rule(boo,
	$and(	$newbarrier(B),
		as(b(B)),
		foo1,
		sleep(3),
		$barrier_broadcast(B))).

$pop(_).

%%======================================================================
%% test gem table
%%----------------------------------------------------------------------

$newcell(test_gem_table).
$push(test_gem_table).

$rule(foo,fork(foo,_)).
$rule(foo1,$and($usleep(10),fork(foo1,_))).
$rule(foo2,$and($msleep(10),fork(foo2,_))).

$rule(bar1,$and(fork(bar1,_),$usleep(10))).
$rule(bar2,$and(fork(bar2,_),$msleep(10))).

$pop(_).

%%======================================================================
%% test gem table
%%----------------------------------------------------------------------

$newcell(test_die).
$push(test_die).

$rule(foo,$and($write(enter_def1),$nl,$die)).
$rule(foo,$and($write(enter_def2_never_come_here),$nl)).

$pop(_).

%%======================================================================
%% garg
%%----------------------------------------------------------------------

$newcell(test_garg).
$push(test_garg).

$new_cellvar(test_garg,n,n0).

$fact(a(1,y(|x(_|a1@a,b1@b)@z))).
$fact(a(2,y(|x(_|b2@b,c1@c)@z))).
$fact(a(3,y(|x(_|a2@a,c2@c,N@n)@z))).
$fact(a(4,y(|x(_|A@a,B@b,C@c)@z))).

$rule($role(Role,Value,Term),
	$and($write($role(Role,Value,Term)),$nl,fail)).
$rule($role(a,1,_),$true).

$rule(foo,$and(
	a(N,Y),
	eq(Y,y(|X@z)),
	$gunify(X,x(N|G@g)),
	$write(X),$nl,
	$term_gargv(X,a,AVal),
	$write(a(AVal)),$nl,
	$eq(XX,x(_|x@a)),
	$gunify(Y,y(|XX@z)),
	$write(succ(Y)),$nl)
	).

$pop(_).

%%======================================================================
%% cut in and
%%----------------------------------------------------------------------

$newcell(test_cut_in_and).
$push(test_cut_in_and).


$rule(foo,$and(bar(X),$write(def1_enter(X)),$nl,$fail)).
$rule(foo,$and($write(def1_fail),$nl,$fail)).

$rule(foo,$and(bar(X),$write(def2_enter(X)),$nl,$cut,$fail)).
$rule(foo,$and($write(def2_fail),$nl,$fail)).

$fact(bar(1)).
$fact(bar(2)).
$fact(bar(3)).

$pop(_).

%%======================================================================
%% cut in and
%%----------------------------------------------------------------------

$newcell(test_if).
$push(test_if).

$rule(if(Cond,Then,Else),
	$and(Cond,!,Then)).
$rule(if(_,_,Else),
	Else).

$rule(if(Cond,Then),
	$and(Cond,!,Then)).

$rule(foo,
	if(true,$and($write(a),$nl,fail))).
$rule(foo,
	if(true,$and($write(b),$nl,!,fail))).

$pop(_).

%%======================================================================
%% while
%%----------------------------------------------------------------------

$newcell(test_while).
$push(test_while).
$new_cellvar(test_while,a,0).

$rule(foo,
	$and(	$cv_put(test_while,a,0,force),
		$while($and(	$cv_get(test_while,a,A,no,no),$comp_lt(A,5))),
		$write(a(A)),$nl,
		$inc(A,A1),$cv_put(test_while,a,A1,force),
		$fail)).
				
$pop(_).

%%======================================================================
%% with
%%----------------------------------------------------------------------

$newcell(test_with).
$push(test_with).

$fact(x(1)).
$fact(x(2)).

$newcell(with_a).
$push(with_a).
$fact(x(a1)).
$fact(x(a2)).
$pop(_).

$rule(foo,
	$and(	x(X),
		$or($true,$and($nl,fail)),
		with(with_a,x(Y)),
		x(Z),
		$write(x(X,Y,Z)),
		fail)).
$pop(_).

%%======================================================================
%% cutlevel
%%----------------------------------------------------------------------

$newcell(test_cutlevel).
$push(test_cutlevel).

$fact(x(1)).
$fact(x(2)).

$rule(foo,
	$and(	$save_cutlevel(CL1i),$write(cl1_i(CL1i)),$nl,
		bar,
		$save_cutlevel(CL1o),$write(cl1_o(CL1o)),$nl,
		!)).

$rule(bar,
	$and(	$save_cutlevel(CL2i),$write(cl2_i(CL2i)),$nl,
		x(X),
		$save_cutlevel(CL2m),$write(cl2_m(CL2m)),$nl,
		$fail)).

$rule(bar,
	$and(	$save_cutlevel(CL3i),$write(cl3_i(CL3i)),$nl,
		x(X),
		$save_cutlevel(CL3m),$write(cl3_m(CL3m)),$nl,
		$restore_cutlevel(CL3i),
		$save_cutlevel(CL3n),$write(cl3_n(CL3n)),$nl,
		$fail)).

$rule(bar,
	$and(	$save_cutlevel(CL4i),$write(cl4_i(CL4i)),$nl,
		x(X),
		$save_cutlevel(CL4m),$write(cl4_m(CL4m)),$nl,
		!,
		$save_cutlevel(CL4n),$write(cl4_n(CL4n)),$nl,
		$fail)).

$rule(bar,
	$and(	$save_cutlevel(CL5i),$write(cl5_i(CL5i)),$nl,
		x(X),
		$save_cutlevel(CL5m),$write(cl5_m(CL5m)),$nl)).

$pop(_).

%%======================================================================
%% cut fail
%%----------------------------------------------------------------------

$newcell(test_cutfail).
$push(test_cutfail).
$rule(foo, foo1).
$rule(foo, foo2).

$rule(foo1, $and(
	$write(def_1),$nl,
	$cut_fail,
	$write(never_come),$nl,
	!)).
$rule(foo1, $and(
	$write(def_2),$nl,
	$cut_fail,
	$write(never_come),$nl,
	!)).
$rule(foo2, $and(
	$write(def_3),$nl,
	$fail,
	$write(never_come),$nl,
	!)).
$rule(foo2, $cut_and(
	$write(def_4),$nl,
	$fail,
	$write(never_come),$nl,
	!)).
$rule(foo2, $cut_and(
	$write(def_5),$nl,
	$fail,
	$write(never_come),$nl,
	!)).

$pop(_).


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
$write('loading succeeded'),$nl.


