// -*- Mode:C++ -*-
//
//======================================================================
// for test
//======================================================================
//
//  Testing circlekicks, should circlekick in nearest direction to
//  180 deg behind, then stop ball.

#include "GSPlayer.h"

enum Mode {
    M_before_kick_off,
    M_play_on,
    M_tired,
    M_error,
} ;


//----------------------------------------------------------------------
// action loop(s)


void PreGameAction(GSPlayer& player, Mode *pMode)
{
    cout << "\n================================" << endl;
    if(player.scycle.count > 0) {
        *pMode = M_play_on ;
        cout << "\n------------------------------------------------------"
             << "\n------------------------------------------------------"
             << "\n------------------------------------------------------"
             << "\n------------------------------------------------------"
             << endl;
        
        player.kickTo(30, 0);
        scSleep(0,500);

        cout << "\n------------------------------------------------------"
             << "\n------------------------------------------------------"
             << "\n------------------------------------------------------"
             << "\n------------------------------------------------------"
             << endl;
        
        return;
    }
    player.move(-.4,0);
    //player.move(-.7,0);
    //player.move(-5,0);
    player.turnTo(0);
    //player.turnTo(90);
    scSleep(1,0);
}


void GameAction(GSPlayer& player)
{
    cout << "\n------------------------------" << endl;
    //player.PosInfo("");
    
    //ScFloat kickDir = scNormalizeAngle(scFltRand(-45, 45) - 180);

    //ScFloat kickPow = 30;
    ScFloat dashPow = 100;


    if (player.scycle.count - (ScUInt) player.ball().ptime > 15) {
        cerr << "\ngscirclekick: haven't seen the ball!" << endl;
        cout << "\ngscirclekick: haven't seen the ball!" << endl;
        for (int i = 0; i < 4; i++) {
            player.waitForVisualInfo();
            if (player.scycle.count - (ScUInt) player.ball().ptime < 15)
                break;
            player.turn(90);
        }
    }
    else if (player.DashKickableP()) {
        ScFloat kickDir = scNormalizeAngle(180 + player.ballAngleRel());

        kickDir = 180;
        
        cerr << "\ngscirckekick: kickDir: " << kickDir << endl;
        cout << "\ngscirclekick: kickDir: " << kickDir << endl;
        
        ScBool doneP = ScFalse;
        
        while (player.KickableP()) {
            cout << "\n-----------" << endl;
            doneP = ScFalse;
            if (  player.circleKick(kickDir, ScTrue, ScTrue, &doneP)  &&
                  doneP) {
                break;
            }
        }

        if (doneP) {
            cout << "\n---------"
                 << "\nDone!"
                 << "\n---------" << endl;
            cout << "\nBallVelAbs.norm() : "
                 << player.ballVelAbs().norm() << endl;
            cerr << "\n---------"
                 << "\nDone!"
                 << "\n---------" << endl;
            cerr << "\nBallVelAbs.norm() : "
                 << player.ballVelAbs().norm() << endl;
        } else {
            cout << "\n---------"
                 << "\nLost ball."
                 << "\n---------" << endl;
            cerr << "\n---------"
                 << "\nLost ball."
                 << "\n---------" << endl;
        }
        scSleep(0,500);
        exit(0);
    }
    else {
        cout << "\n---dashing"<<endl;
        player.stepDashToBall2(dashPow);
        if (player.DashKickableP()) {
            cout << "\n---getting vision"<<endl;
            player.waitForFullVisualInfo();
        }
    }
}


void ActionLoop(GSPlayer& player)
{
    Mode mode = M_before_kick_off;
    
    while(ScTrue) {
        if (mode == M_before_kick_off) {
            PreGameAction(player, &mode);
        }

        else if (mode == M_play_on) {
            if (player.scycle.count - player.ecycle.count > 20) {
                cout << "\n================================" << endl;
                cout << player << "I lost my position." << endl;
                for(ScUInt i = 0; i < 6; i++) {
                    player.turn(80);
                }
            }
            else if (player.actualBodyState.stamina < 1000) {
                cout << "\n================================" << endl;
                cout << player << "I am tired." << endl;
                mode = M_tired;
            }
            else {
                GameAction(player);
            }
        }

        else if (mode == M_tired) {
            cout << "\n================================" << endl;
            player.turn(10);
            if(player.actualBodyState.stamina > 3000) {
                cout << player << "I'm refleshed!!" << endl;
                mode = M_play_on;
            }
        }

    }  // end while loop
}
    

//----------------------------------------------------------------------
// sensor loop

void sensorLoop(GSPlayer& player)
{
    ScBool r;
    while(ScTrue) {
        r = player.recvScanSInfo();
    }
}


void* sensorLoopEntry(void* p)
{
    sensorLoop(*(GSPlayer*)p);
    return NULL;
}


//----------------------------------------------------------------------
// option

#define DEFAULT_HOST		"localhost"
#define DEFAULT_PORT		6000
#define DEFAULT_TEAMNAME	"Japan"
#define DEFAULT_PROTO_VERSION	5.0

char* SHost = DEFAULT_HOST;
ScInt SPort = DEFAULT_PORT;
char* TeamName = DEFAULT_TEAMNAME;
ScFloat ProtocolVersion = DEFAULT_PROTO_VERSION;
ScBool GoalieP = ScFalse;

ScBool getOption(int argc, char** argv) {
    for(int i = 1; i < argc; i++) {
        if        (!strcmp(argv[i],"-host")) {
            i++; SHost = argv[i];
        } else if (!strcmp(argv[i],"-port")) {
            i++; SPort = atol(argv[i]);
        } else if (!strcmp(argv[i],"-team")) {
            i++; TeamName = argv[i];
        } else if (!strcmp(argv[i],"-protocol")) {
            i++; ProtocolVersion = atof(argv[i]);
        } else if (!strcmp(argv[i],"-goalie")) {
            GoalieP = ScTrue;
        } else {
            if (strcmp(argv[i],"-help")) {
                cerr << "Illegal option:" << argv[i] << endl;
            } 
            cerr << "Usage:" << endl;
            cerr << "\t % gstest [options]" << endl;
            cerr << "\t     [options]" << endl;
            cerr << "\t\t-host HOST" << endl;
            cerr << "\t\t-port PORT" << endl;
            cerr << "\t\t-team TEAM" << endl;
            cerr << "\t\t-protocol PROTOCOL" << endl;
            cerr << "\t\t-goalie GOALIE" << endl;
            exit(1);
        }
    }
    return ScTrue;
}

	    

//----------------------------------------------------------------------
// main for test

main(int argc, char** argv) {
    scRandomizeByTime() ;
    getOption(argc,argv);

    // cout << "Try to open socket to host:port=" 
    // << SHost << ":" << SPort << endl;

    GSPlayer player;
    player.init(ScString(TeamName),SHost,SPort,ScFalse);
   
    // cout << "Succeed to open socket." << endl;

    if(!player.sendInit(ProtocolVersion,GoalieP)) {
        cerr << "Can't send init command" << endl;
        exit(1);
    }

    // cout << "Start sensor loop." << endl;

    pthread_t sensor_thread;
    pthread_create(&sensor_thread, SC_NULLPTR, sensorLoopEntry,
                   (void*)&player);

    // cout << "Enter simple command loop." << endl;

    ActionLoop(player);
}
