// -*- Mode:C++ -*-
//Header:
//File: gsmttest.cc
//Author: NDOA, Itsuki
//Date: 1999/06/09
//

//ModifyHistory:
// 1999/06/09: Create this file
//EndModifyHistory:

#include "GSPlayer.h"

//======================================================================
// for test
//======================================================================

void waitSeeInfo(GSPlayer& player, ScUInt n) {
   for(ScUInt c = 0 ; c < n ;) {
      ScBool r = player.recvScanSInfo() ;
      if(r && player.sinfo.type == SC_SIT_see) c++ ;
   }
}

//----------------------------------------------------------------------
// sensor loop

void sensorLoop(GSPlayer& player) {
   while(ScTrue) {
      ScBool r = player.recvScanSInfo() ;
      /*
      if(!r) {
	 cout << '?' << flush ;
      } else {
	 switch(player.sinfo.type) {
	    case SC_SIT_see:        { cout << 's' << flush ; break ; }
	    case SC_SIT_hear:       { cout << 'h' << flush ; break ; } 
	    case SC_SIT_senseBody : { cout << 'b' << flush ; break ; } 
	    default:                { cout << '-' << flush ; break ; } 
	 }
      }
      */
   }
}

void* sensorLoopEntry(void* p) {
   sensorLoop(*(GSPlayer*)p) ;
   return NULL ;
}

//----------------------------------------------------------------------
// random Loop

enum Mode {
   M_before_kick_off,
   M_play_on,
   M_tired,
   M_error,
} ;

void randomLoop(GSPlayer& player) {
   Mode mode = M_before_kick_off ;

   scRandomizeByTime() ;

   ScPos destPos ;
   ScInt pTime ;
   pTime = -10000 ;
   
   while(ScTrue) {
      if(mode == M_before_kick_off) {
	 ScFloat x = scFltRand(-SC_HALF_PITCH_L,0) ;
	 ScFloat y = scFltRand(-SC_HALF_PITCH_W,SC_HALF_PITCH_W) ;
	 player.move(x,y) ; 
	 scSleep(0,500) ;
	 player.turn(scFltRand(-90,90)) ; 
	 scSleep(0,500) ;
	 if(player.scycle.count > 0) mode = M_play_on ;

      } else if (mode == M_play_on) {
	 if(player.scycle.count - player.ecycle.count > 20) {
	    cout << player << "I lost my position." << endl ;
	    for(ScUInt i = 0 ; i < 6 ; i++) {
	       player.turn(80) ;
	    }

	 } else if(player.KickableP(3)) {
	    ScFloat dir = scFltRand(-90,90) ;
	    player.kick(100,dir) ;
	    cout << player << "Kick(100," << dir << ")" << endl ;

	 } else if((player.xposdir.pos.x > SC_HALF_PITCH_L &&
		    scAbs(player.eposdir.bdir) <= 90) ||
		   (player.xposdir.pos.x < -SC_HALF_PITCH_L &&
		    scAbs(player.eposdir.bdir) >= 90) ||
		   (player.xposdir.pos.y > SC_HALF_PITCH_W &&
		    player.xposdir.bdir >= 0) ||
		   (player.xposdir.pos.y < -SC_HALF_PITCH_W &&
		    player.xposdir.bdir <= 0)) {
	    cout << player << "I am out of field." << endl ;
	    player.turn(scFltRand(-180,180)) ;

	 } else if(player.actualBodyState.stamina < 1000) {
	    cout << player << "I am tired." << endl ;
	    mode = M_tired ;

//	 } else if(player.isMyBallInTeammate()) {
	 } else if(player.closestTeamMemberToBallP()) {
//	    cout << player << "My Ball!!!" << endl ;
	    player.stepGoto(player.ball().posdir.pos,100) ;

	 } else if(scDistance(player.xposdir.pos,destPos) < 2.0 ||
		   player.scycle.count - pTime > 1000) {
	    destPos.x = scFltRand(-SC_HALF_PITCH_L,SC_HALF_PITCH_L) ;
	    destPos.y = scFltRand(-SC_HALF_PITCH_W,SC_HALF_PITCH_W) ;
	    pTime = player.scycle.count ;
	    cout << player << "I change mind." << destPos << endl;
	    
	 } else {
	    player.stepGoto(destPos,50) ;
	 }

      } else if (mode == M_tired) {
	 player.turn(10) ;
	 if(player.actualBodyState.stamina > 3000) {
	    cout << player << "I'm refleshed!!" << endl ;
	    mode = M_play_on ;
	 }
      }
//      cout << "epos" << player.eposdir.pos << endl ; 
//      cout << "xpos" << player.xposdir.pos << endl ; 
/*
      cout << "stamina=" << player.actualBodyState.stamina 
	   << ",effort=" << player.actualBodyState.effort 
	   << endl ;
*/
//      cout << "ball.pos=" << player.objectTable.ball << endl ;
   }
} 



//----------------------------------------------------------------------
// random Loop 2

void randomLoop2(GSPlayer& player) {
   player.simulationTic.set(0,60,0) ;
   scSleep(1) ;
   player.move(-10,0) ;
   scSleep(5) ;
   for(ScUInt i = 0 ; i < 10 ; i++) {
      player.turn(10) ;
      cout << '*' << flush ;
   }

//   for(ScUInt i = 0 ; i < 200 ; i++) {
//      player.recvScanSInfo() ;
//      cout << '.' << flush ;
//   }
   ScInt c = player.recvScanSInfoAll() ;
   cout << "receive " << c << " sensor informations." << endl ;


   player.actualBodyState.describe(cout) ;
}

//----------------------------------------------------------------------
// test main loop

ScInt Role = 0 ;

void testLoop(GSPlayer& player) {
   player.simulationTic.set(0,100,0) ;
   scSleep(1) ;

   switch(Role) {
      case 0 : {
	 player.move(-1,0) ;
	 exit(0) ;
      } 
      case 1 : {
	 player.move(-5,-5) ;
	 scSleep(1) ;
	 while(player.scycle.count <= 0) { 
	    player.turn(30) ;
	    scSleep(0,100) ; 
	 } ;
	 for(ScInt i = 0 ; i < 10 ; i++) {
	    scSleep(0,150) ;
	    player.turnToAbs(player.ball().posdir.pos) ;
	 } ;
	 player.objectTable.describe(cout) ;
//	 if(player.isMyBallInTeammate()) {
	 if(player.closestTeamMemberToBallP()) {
	    cout << "I'm the nearest player." << endl ;
	 } else {
	    cout << "Other player is playing." << endl ;
	 }
	 exit(0) ;
      }
      default : {
	 cout << "Error" << endl ;
	 exit(1) ;
      }
   }
}

//----------------------------------------------------------------------
// option

#define DEFAULT_HOST		"localhost"
#define DEFAULT_PORT		6000
#define DEFAULT_TEAMNAME	"Japan"
#define DEFAULT_PROTO_VERSION	5.0

char* SHost = DEFAULT_HOST ;
ScInt SPort = DEFAULT_PORT ;
char* TeamName = DEFAULT_TEAMNAME ;
ScFloat ProtocolVersion = DEFAULT_PROTO_VERSION ;
ScBool GoalieP = ScFalse ;

ScBool getOption(int argc, char** argv) {
   for(int i = 1 ; i < argc ; i++) {
      if        (!strcmp(argv[i],"-host")) {
	 i++ ; SHost = argv[i] ;
      } else if (!strcmp(argv[i],"-port")) {
	 i++ ; SPort = atol(argv[i]) ;
      } else if (!strcmp(argv[i],"-team")) {
	 i++ ; TeamName = argv[i] ;
      } else if (!strcmp(argv[i],"-role")) {
	 i++ ; Role = atol(argv[i]) ;
      } else if (!strcmp(argv[i],"-protocol")) {
	 i++ ; ProtocolVersion = atof(argv[i]) ;
      } else if (!strcmp(argv[i],"-goalie")) {
	 GoalieP = ScTrue ;
      } else {
	 if (strcmp(argv[i],"-help")) {
	    cerr << "Illegal option:" << argv[i] << endl ;
	 } 
	 cerr << "Usage:" << endl ;
	 cerr << "\t % gstest [options]" << endl ;
	 cerr << "\t     [options]" << endl ;
	 cerr << "\t\t-host HOST" << endl ;
	 cerr << "\t\t-port PORT" << endl ;
	 cerr << "\t\t-team TEAM" << endl ;
	 cerr << "\t\t-protocol PROTOCOL" << endl ;
	 cerr << "\t\t-goalie GOALIE" << endl ;
	 exit(1) ;
      }
   }
   return ScTrue ;
}

	    

//----------------------------------------------------------------------
// main for test

main(int argc, char** argv) {

   getOption(argc,argv) ;

//   cout << "Try to open socket to host:port=" 
//	<< SHost << ":" << SPort << endl ;

   GSPlayer player ;
   player.init(ScString(TeamName),SHost,SPort,ScFalse) ;

   
//   cout << "Succeed to open socket." << endl ;

   if(!player.sendInit(ProtocolVersion,GoalieP)) {
      cerr << "Can't send init command" << endl ;
      exit(1) ;
   }

//   cout << "Start sensor loop." << endl ;

   pthread_t sensor_thread ;
   pthread_create(&sensor_thread, SC_NULLPTR, sensorLoopEntry, (void*)&player) ;

//   cout << "Enter simple command loop." << endl ;

//   randomLoop(player) ;
//   randomLoop2(player) ;
   testLoop(player) ;

}

