// -*- Mode:C++ -*-
//Header:
//File: comclient.cc
//Author: NDOA, Itsuki
//Date: 1999/04/17
//

//ModifyHistory:
// 1999/04/17: Create this file
//EndModifyHistory:

#include "libsclient.h"


//----------------------------------------------------------------------
// simple com loop

ScBool simpleCommandAnalyzer(ScPlayer& player, char* buf) {
   cout << "command:" << buf << endl ;
   if(buf[0] == '(') {
      strcpy((char*)player.sendBuffer,buf) ;
      return player.send() ;
   } else {
      ScFloat arg1, arg2 ;
      if(2 == sscanf(buf,"m %lf %lf",&arg1, &arg2)) {
	 return player.sendMove(arg1,arg2) ;
      } 
      if(1 == sscanf(buf,"t %lf",&arg1)) {
	 return player.sendTurn(arg1) ;
      }
      if(1 == sscanf(buf,"d %lf",&arg1)) {
	 return player.sendDash(arg1) ;
      }
      if(2 == sscanf(buf,"k %lf %lf",&arg1, &arg2)) {
	 return player.sendKick(arg1,arg2) ;
      } 
      if(1 == sscanf(buf,"c %lf",&arg1)) {
	 return player.sendCatch(arg1) ;
      }
      if(1 == sscanf(buf,"n %lf",&arg1)) {
	 return player.sendTurnNeck(arg1) ;
      }
      if(buf[0] == 'z') { return player.sendTurn(-90) ; }
      if(buf[0] == 'x') { return player.sendTurn(-10) ; }
      if(buf[0] == 'c') { return player.sendTurn( 10) ; }
      if(buf[0] == 'v') { return player.sendTurn( 90) ; }
      if(buf[0] == 'd') { return player.sendDash(100) ; }
      if(buf[0] == ' ') { return player.sendKick(100,0) ; }
      if(buf[0] == 'a') { return player.sendKick(100,-90) ; }
      if(buf[0] == 's') { return player.sendKick(100,-20) ; }
      if(buf[0] == 'f') { return player.sendKick(100, 20) ; }
      if(buf[0] == 'g') { return player.sendKick(100, 90) ; }

      if(buf[0] == 'h') { 
	 cerr << "Usage:" << endl ;
	 cerr << "\tm X Y     :  move X Y" << endl ;
	 cerr << "\tt Pow     :  turn Pow" << endl ;
	 cerr << "\td Pow     :  dash Pow" << endl ;
	 cerr << "\tk Pow Dir :  kick Pow Dir" << endl ;
	 cerr << "\tn Pow     :  turn_neck Pow" << endl ;
	 cerr << "\tc Dir     :  catch Dir" << endl ;
	 cerr << "\ts Msg     :  Say Msg" << endl ;
	 cerr << "\tz         :  turn -90" << endl ;
	 cerr << "\tx         :  turn -10" << endl ;
	 cerr << "\tc         :  turn  10" << endl ;
	 cerr << "\tv         :  turn  90" << endl ;
	 cerr << "\td         :  dash 100" << endl ;
	 cerr << "\tSpace     :  kick 100 0" << endl ;
	 cerr << "\ta         :  kick 100 -90" << endl ;
	 cerr << "\ts         :  kick 100 -20" << endl ;
	 cerr << "\tf         :  kick 100  20" << endl ;
	 cerr << "\tg         :  kick 100  90" << endl ;
	 return ScTrue ;
      }
   }
}

ScBool simpleCommandLoop(ScPlayer& player, istream& istr, ostream& ostr) {

   ScSocket& sock = player.socket ;

   streambuf* sin = istr.rdbuf() ;
   streambuf* sout = ostr.rdbuf() ;

   int sin_id = fileno((FILE*)sin) ;

   ///// setup select readfds mask
   fd_set readfds ;
   FD_ZERO(&readfds) ;
   FD_SET(sin_id,&readfds) ;
   FD_SET(sock.socketfd,&readfds) ;
   int max_fd = scMax((ScInt)(sock.socketfd),(ScInt)sin_id) + 1;

   char buf[SC_BUFSIZE] ;

   while(ScTrue) {

      ///// reset mask
      fd_set rfds ; rfds = readfds ;

      ///// select
      int r = select(max_fd, &rfds, SC_NULLPTR, SC_NULLPTR, SC_NULLPTR) ;

      ///// check error
      if(r < 0) {
	 cerr << "Error: fail select operation." << endl ;
	 return ScFalse ;
      }

      ///// skip no selection
      if(r == 0) continue ;

      ///// stdin -> socket
      if(FD_ISSET(sin_id,&rfds)) {
//	 fgets((char*)player.sendBuffer,player.sendBuffer.length(),sin) ;
	 fgets(buf,SC_BUFSIZE,(FILE*)sin) ;
	 if(!simpleCommandAnalyzer(player,buf)) {
	    cerr << "Error: fail to send." << endl ;
	    return ScFalse ;
	 }
      }
      
      ///// socket -> stdout
      if(FD_ISSET(sock.socketfd,&rfds)) {
	 if(player.recvScanSInfo()) {
//	    player.sinfo.describe(cout) ;
	    if        (player.sinfo.type == SC_SIT_see) {
	       cout << player.eposdir << player.evel << endl ;
	    } else if (player.sinfo.type == SC_SIT_hear) {
	       cout << player.sinfo.info.hear ;
	       if(player.sinfo.info.hear.sender == SC_ST_referee) {
		  cout << ":" << player.sinfo.info.hear.aux.pmode->id ;
	       }	       cout << endl ;
	    }
	 }
      }
   }
   return ScTrue ; 
}   

//----------------------------------------------------------------------
// option

#define DEFAULT_HOST		"localhost"
#define DEFAULT_PORT		6000
#define DEFAULT_TEAMNAME	"Japan"
#define DEFAULT_PROTO_VERSION	5.0

char* SHost = DEFAULT_HOST ;
ScInt SPort = DEFAULT_PORT ;
char* TeamName = DEFAULT_TEAMNAME ;
ScFloat ProtocolVersion = DEFAULT_PROTO_VERSION ;
ScBool GoalieP = ScFalse ;

ScBool getOption(int argc, char** argv) {
   for(int i = 1 ; i < argc ; i++) {
      if        (!strcmp(argv[i],"-host")) {
	 i++ ; SHost = argv[i] ;
      } else if (!strcmp(argv[i],"-port")) {
	 i++ ; SPort = atol(argv[i]) ;
      } else if (!strcmp(argv[i],"-team")) {
	 i++ ; TeamName = argv[i] ;
      } else if (!strcmp(argv[i],"-protocol")) {
	 i++ ; ProtocolVersion = atof(argv[i]) ;
      } else if (!strcmp(argv[i],"-goalie")) {
	 GoalieP = ScTrue ;
      } else {
	 if (strcmp(argv[i],"-help")) {
	    cerr << "Illegal option:" << argv[i] << endl ;
	 } 
	 cerr << "Usage:" << endl ;
	 cerr << "\t % comclient [options]" << endl ;
	 cerr << "\t     [options]" << endl ;
	 cerr << "\t\t-host HOST" << endl ;
	 cerr << "\t\t-port PORT" << endl ;
	 cerr << "\t\t-team TEAM" << endl ;
	 cerr << "\t\t-protocol PROTOCOL" << endl ;
	 cerr << "\t\t-goalie GOALIE" << endl ;
	 exit(1) ;
      }
   }
   return ScTrue ;
}

	    

//----------------------------------------------------------------------
// main for test

main(int argc, char** argv) {

   getOption(argc,argv) ;

//   cout << "Try to open socket to host:port=" 
//	<< SHost << ":" << SPort << endl ;

   ScPlayer player ;
   player.init(ScString(TeamName),SHost,SPort,ScFalse) ;
   
//   cout << "Succeed to open socket." << endl ;

   if(!player.sendInit(ProtocolVersion,GoalieP)) {
      cerr << "Can't send init command" << endl ;
      exit(1) ;
   }

//   cout << "Enter simple command loop." << endl ;
   simpleCommandLoop(player,cin,cout) ;
   
}




