// -*- Mode:C++ -*-
//Header:
//File: eposcheck.cc
//Author: NDOA, Itsuki
//Date: 1999/04/21
//

//ModifyHistory:
// 1999/04/21: Create this file
//EndModifyHistory:

#include "libsclient.h"


//----------------------------------------------------------------------
// simple com loop

ScFloat Dir = 0.0 ;

void waitSeeInfo(ScPlayer& player, ScUInt n) {
   for(ScUInt c = 0 ; c < n ;) {
      player.recvScanSInfo() ;
      if(player.sinfo.type == SC_SIT_see) c++ ;
   }
}

void posCheck(ScPlayer& player, ScFloat dir) {
   waitSeeInfo(player,2) ;

   player.sendTurn(dir) ; 
   Dir += dir ;
   waitSeeInfo(player,1) ;

   ScPos pos ;
   for(pos.x = -1.0 ; pos.x > -53 ; pos.x -= 1.0) {
      for(pos.y = -33 ; pos.y < 34 ; pos.y += 1.0) {
	 player.sendMove(pos) ;
	 waitSeeInfo(player,1) ;
	 printf("[%6.2lf=%6.2lf] (%6.2lf,%6.2lf)=(%6.2lf,%6.2lf)  : %6.2lf / %7.5lf\n",
		Dir, player.eposdir.hdir,
		pos.x, pos.y,
		player.eposdir.pos.x, player.eposdir.pos.y,
		scDistance(pos,player.eposdir.pos),
		player.eposConf
		) ;
      }
   }
}
//----------------------------------------------------------------------
// option

#define DEFAULT_HOST		"localhost"
#define DEFAULT_PORT		6000
#define DEFAULT_TEAMNAME	"Japan"
#define DEFAULT_PROTO_VERSION	5.0

char* SHost = DEFAULT_HOST ;
ScInt SPort = DEFAULT_PORT ;
char* TeamName = DEFAULT_TEAMNAME ;
ScFloat ProtocolVersion = DEFAULT_PROTO_VERSION ;
ScBool GoalieP = ScFalse ;

ScBool getOption(int argc, char** argv) {
   for(int i = 1 ; i < argc ; i++) {
      if        (!strcmp(argv[i],"-host")) {
	 i++ ; SHost = argv[i] ;
      } else if (!strcmp(argv[i],"-port")) {
	 i++ ; SPort = atol(argv[i]) ;
      } else if (!strcmp(argv[i],"-team")) {
	 i++ ; TeamName = argv[i] ;
      } else if (!strcmp(argv[i],"-protocol")) {
	 i++ ; ProtocolVersion = atof(argv[i]) ;
      } else if (!strcmp(argv[i],"-goalie")) {
	 GoalieP = ScTrue ;
      } else if (!strcmp(argv[i],"-dir")) {
	 i++ ; Dir = atof(argv[i]) ;
      } else {
	 if (strcmp(argv[i],"-help")) {
	    cerr << "Illegal option:" << argv[i] << endl ;
	 } 
	 cerr << "Usage:" << endl ;
	 cerr << "\t % comclient [options]" << endl ;
	 cerr << "\t     [options]" << endl ;
	 cerr << "\t\t-host HOST" << endl ;
	 cerr << "\t\t-port PORT" << endl ;
	 cerr << "\t\t-team TEAM" << endl ;
	 cerr << "\t\t-protocol PROTOCOL" << endl ;
	 cerr << "\t\t-goalie GOALIE" << endl ;
	 exit(1) ;
      }
   }
   return ScTrue ;
}

	    

//----------------------------------------------------------------------
// main for test

main(int argc, char** argv) {

   getOption(argc,argv) ;

//   cout << "Try to open socket to host:port=" 
//	<< SHost << ":" << SPort << endl ;

   ScPlayer player ;
   player.init(ScString(TeamName),SHost,SPort,ScFalse) ;
   
//   cout << "Succeed to open socket." << endl ;

   if(!player.sendInit(ProtocolVersion,GoalieP)) {
      cerr << "Can't send init command" << endl ;
      exit(1) ;
   }

//   cout << "Enter simple command loop." << endl ;
   
   player.sendTurn(Dir) ;
   ScFloat dDir = 20 ;
   for(ScUInt i = 0 ; i < 18 ; i++) {
      posCheck(player,dDir) ;
   }
}




