%% -*- mode: prolog -*-
%%Header:
%%File: strategy.mg
%%EndHeader:






%%V.1.04noda3
%%#define DEBUG

%%======================================================================
%% for debug
%%


%%======================================================================
%% strategy node template
%%

newcell(strategy).
push(strategy).

%%----------------------------------------------------------------------
%% define node

$rule(define_node(Node,
		WatchInterval,WatchSignals,
		Children,CFThreshold),
		
	$and(
%
	newcell_if_need(Node),
%	push(node_base,Node),
	push(Node),
	asserta(node(Node)),

	$new_cellvar(Node,interval,WatchInterval),
	$is(IntUSec,mul(WatchInterval,1000)),
	$new_cellvar(Node,interval_usec,IntUSec),

	$new_cellvar(Node,signal_list,WatchSignals),

	$new_cellvar(Node,children,Children),
	link_mother_children(Node,Children),

	$new_cellvar(Node,cf_threshold,CFThreshold),

	$new_cellvar(Node,cf,0.0),

	$new_cellvar(Node,selected_child,[]),

	$ctime(Sec,USec),
	$new_cellvar(Node,last_update_time_sec,Sec),
	$new_cellvar(Node,last_update_time_usec,USec),

	new_cellvar_if_need(Node,mother,[]),

	pop(Node),
%
	!)).

$rule(newcell_if_need(Cell),$or(
	$cell_exist(Cell),
	$newcell(Cell))).

$rule(new_cellvar_if_need(Node,CellVar,InitVar),$or(
	$cellvar_exist(Node,CellVar),
	$new_cellvar(Node,CellVar,InitVar))).

$rule(link_mother_children(Mother,[]),!).
$rule(link_mother_children(Mother,[Child|Rest]), $and(
	newcell_if_need(Child),
	new_cellvar_if_need(Child,mother,Mother),
	$cv_put( Child , mother , Mother ,force) ,
	link_mother_children(Mother,Rest),
	!)).

define_node([],0,[],[],0.0).
push([]).
$rule(activate,!).
$rule(deactivate,!).
pop([]).

pop(_).


%%======================================================================
%% planning base cell

newcell(planning_base).
$new_cellvar(planning_base,w_time_up_msec,0).
$new_cellvar(planning_base,topnode,[]).
push(planning_base).

%%----------------------------------------------------------------------
%% top level roop

$rule(toploop,$and(
	$repeat,
	cycle,
	$fail,
	!)).

%%----------------------------------------------------------------------
%% cycle (toplevel)

$rule(cycle, $and(
	correct_signal(SignalList,TimeUpMSec),
	$timedwait_signal(Signal,SignalList,0,TimeUpMSec),
	cycle(Signal),
	!)).

%%----------------------------------------------------------------------
%% active tree

$rule(active_tree(Tree), $and(
	$cv_get( planning_base , topnode ,  TopNode  ,no,yes)  ,
	active_tree_sub(TopNode,Tree),
	!)).
$rule(active_tree_sub(Node,[Node | ChildrenList]),$and(
	$cv_get( Node , children , Children ,no,yes) ,
	$cv_get( Node , selected_child , Child ,no,yes) ,
	active_tree_children(Children,ChildrenList,Child))).
$rule(active_tree_children([],[],SChild), !).
$rule(active_tree_children([SChild|Rest],[ChildNode|RestList],SChild),
   $and(
	active_tree_sub(SChild,ChildNode),
	active_tree_children(Rest,RestList,SChild),
	!)).
$rule(active_tree_children([Child|Rest],[Child|RestList],SChild),
   $and(
	active_tree_children(Rest,RestList,SChild),
	!)).

%%----------------------------------------------------------------------
%% correct signal

$rule(correct_signal(SignalList,TimeUpMSec), $and(
	$cv_get( planning_base , topnode ,  TopNode  ,no,yes)  ,
	$cv_put( planning_base , w_time_up_msec , 100000 ,force) ,
	correct_signal_selected(TopNode,SignalList,[]),
	$cv_get( planning_base , w_time_up_msec , TimeUpMSec ,no,yes) ,
	!)).

$rule(correct_signal_one(Node,SListHead,SListTail), $and(
	$cv_get( Node , signal_list , SList1 ,no,yes) ,
	append(SList1,SListTail,SListHead),
	check_earliest_timeup(Node),
        !)).
$rule(correct_signal_selected(Node,SListHead,SListTail), $and(
	correct_signal_one(Node,SListHead,SListMid),
	$cv_get( Node , children , Children ,no,yes) ,
	$cv_get( Node , selected_child , SChild ,no,yes) ,
	correct_signal_body_list(Children,SChild,SListMid,SListTail),
	!)).

$rule(correct_signal_body_list([],SChild,Tail,Tail),!).
$rule(correct_signal_body_list([SChild | Rest], SChild, SListHead, SListTail),
      $and(
	correct_signal_selected(SChild,SListHead,SListMid),
	correct_signal_body_list(Rest,SChild,SListMid,SListTail),
	!)).
$rule(correct_signal_body_list([Child | Rest], SChild, SListHead, SListTail),
      $and(
	correct_signal_one(Child,SListHead,SListMid),
	correct_signal_body_list(Rest,SChild,SListMid,SListTail),
	!)).

%%----------------------------------------------------------------------
%% chek earliest timeup

$rule(check_earliest_timeup(Node), $and(
	$cv_get( planning_base , w_time_up_msec , MSec1 ,no,yes) ,
	$cv_get( Node , interval , MSec2 ,no,yes) ,
	$comp_lt(MSec2,MSec1),
	$cv_put( planning_base , w_time_up_msec , MSec2 ,force) ,
	!)).
$rule(check_earliest_timeup(Node), !).

%%----------------------------------------------------------------------
%% cycle for signal

% $rule(cycle(Signal), $and($write(Signal),$nl,$fail)).
$rule(cycle(Signal), $and(
	$cv_get( planning_base , topnode ,  TopNode  ,no,yes)  ,
	cycle(Signal,TopNode),
	!)).

$rule(cycle(Signal,Node), $and(
	check_update(Signal,Node),
	$cv_get( Node , children , Children ,no,yes) ,
	$cv_get( Node , selected_child , SChild ,no,yes) ,
	cycle_list(Signal,Children,SChild),
	!)).

$rule(cycle_list(Signal,[],SChild),!).
$rule(cycle_list(Signal,[Child | Rest],SChild), $and(
	not(awakep(Child)),
	!)).
$rule(cycle_list(Signal,[SChild | Rest],SChild), $and(
	cycle(Signal,SChild),
	cycle_list(Signal,Rest,SChild),
	!)).
$rule(cycle_list(Signal,[Child | Rest],SChild), $and(
	check_update(Signal,Child),
	cycle_list(Signal,Rest,SChild),
	!)).

%%----------------------------------------------------------------------
%% active?

$rule(activep([]),!).
$rule(activep(Node), $and(
	$cv_get( planning_base , topnode ,  TopNode  ,no,yes)  ,
	activep(Node,TopNode))).
$rule(activep(TopNode,TopNode),!).
$rule(activep(Node,TopNode),$and(
	$cv_get( Node , mother , Mother ,no,yes) ,
	$cv_get( Mother , selected_child , Node ,no,yes) ,!,
	activep(Mother,TopNode))).

$rule(awakep(Node), $and(
	$cv_get( Node , mother , Mother ,no,yes) ,
	activep(Mother),
	!)).

%% V.1.04noda3

$rule(write_node, !).



%%----------------------------------------------------------------------
%% check & update

$rule(check_update(Signal,Node), $and(
	should_update(Node),
	update(Node),
	!)).
$rule(check_update(Signal,Node), !).

%%----------------------------------------------------------------------
%% check should update

$rule(should_update(Node), !).
$rule(should_update(Node), $and(
%	awakep(Node),
	$cv_get( Node , signal_list , SList ,no,yes) ,
	$cv_get( Node , last_update_time_sec , Sec ,no,yes) ,
	$cv_get( Node , last_update_time_usec , USec ,no,yes) ,
	should_update_sub(SList,Node,Sec,USec),
	!)).

%% $rule(should_update_sub([],Node,Sec,USec),$cut_fail).
$rule(xxshould_update_sub([],Node,Sec,USec),$cut_and(
	$ctime(CSec,CUSec),
	$utimedif(Sec,USec,CSec,CUSec,Diff),
	$cv_get( Node , interval_usec , Interval ,no,yes) ,
	$comp_gt(Diff,Interval))).
$rule(should_update_sub([Signal | Rest],Node,Sec,USec), 
	$signal_is_newer(Signal,Sec,USec)).
$rule(should_update_sub([Signal | Rest],Node,Sec,USec), $cut_and(
	should_update_sub(Rest,Node,Sec,USec))).

%%----------------------------------------------------------------------
%% update operation

$rule(update(Node), $and(
	$push(Node),condition(NewCF),$pop(_),!,
	$cv_get( Node , cf , OldCF ,no,yes) ,
	$cv_put( Node , cf , NewCF ,force) ,
	propagate_upper(Node,OldCF,NewCF),
	$ctime(Sec,USec),
	$cv_put( Node , last_update_time_sec , Sec ,force) ,
	$cv_put( Node , last_update_time_usec , USec ,force) ,
	!)).

%%----------------------------------------------------------------------
%% condition check fall-down bottom 

$rule(condition(_,0),!).

%%----------------------------------------------------------------------
%% propagate to upper level node

$rule(propagate_upper(Node,CF,CF),!).	% do nothing if no change
$rule(propagate_upper(Node,OldCF,NewCF), $and(
	$comp_gt(NewCF,OldCF),!,
	$cv_get( Node , mother , Mother ,no,yes) ,
	propagate_to_mother_increase(Mother,Node,NewCF),
	!)).
$rule(propagate_upper(Node,OldCF,NewCF), $cut_and(
	$cv_get( Node , mother , Mother ,no,yes) ,
	propagate_to_mother_decrease(Mother,Node,NewCF),
	!)).

%%----------------------------------------------------------------------
%% propagate to mother in the case increase/decrease

$rule(propagate_to_mother_increase([],Node,NewCF), !).
$rule(propagate_to_mother_increase(Mother,Node,NewCF), $and(
	$cv_get( Mother , selected_child , Node ,no,yes) ,
	!)).
$rule(propagate_to_mother_increase(Mother,Node,NewCF), $and(
	$cv_get( Mother , selected_child , OldChild ,no,yes) ,
	$cv_get( OldChild , cf , OldCF ,no,yes) ,
	$comp_gt(NewCF,OldCF),
	switch_child(Mother,OldChild,Node),
	!)).

$rule(propagate_to_mother_decrease([],Node,NewCF), !).
$rule(propagate_to_mother_decrease(Mother,Node,NewCF), $and(
	$cv_get( Mother , selected_child , Node ,no,yes) ,
	find_maxcf_child(Mother,NewNode),
	switch_child(Mother,Node,NewNode),
	!)).
$rule(propagate_to_mother_decrease(Mother,Node,NewCF), !).

%%----------------------------------------------------------------------
%% switch_child

$rule(switch_child(Mother,Same,Same), !).
$rule(switch_child(Mother,Old,[]), $and(
	with(Old,deactivate),
	active_init(Mother),
	$cv_put( Mother , selected_child , [] ,force) ,
	with(Mother,activate))).
$rule(switch_child(Mother,[],New), $and(
	with(Mother,deactivate),
	active_init(New),
	$cv_put( Mother , selected_child , New ,force) ,
	with(New,activate))).
$rule(switch_child(Mother,Old,New), $and(
	with(Old,deactivate),
	active_init(New),
	$cv_put( Mother , selected_child , New ,force) ,
	with(New,activate))).

$rule(active_init(NewNode), $and(
	$cv_put( NewNode , selected_child , [] ,force) ,
	$cv_get( NewNode , children , Children ,no,yes) ,
	reset_cf_list(Children),
	!)).
$rule(reset_cf_list([]),$true).
$rule(reset_cf_list([Child | Rest]),$and(
	$cv_put( Child , cf , 0.0 ,force) ,
	reset_cf_list(Rest))).

%%----------------------------------------------------------------------
%% fall down action of activate/deactivate

$rule(activate, $and($write(activate_do_nothing),$nl)).
$rule(deactivate, $and($write(deactivate_do_nothing),$nl)).

%%----------------------------------------------------------------------
%% find_maxcf_child

$rule(find_maxcf_child(Mother,NewChild), $and(
	$cv_get( Mother , children , Children ,no,yes) ,
	$cv_get( Mother , cf_threshold , InitCF ,no,yes) ,
	find_maxcf_child_list(Children,NewChild,[],InitCF),
	!)).

$rule(find_maxcf_child_list([],Child,Child,_),!).
$rule(find_maxcf_child_list([Child|Rest],MaxChild,CChild,CCF), $and(
	$cv_get( Child , cf , CF ,no,yes) ,
	$comp_gt(CF,CCF),
	find_maxcf_child_list(Rest,MaxChild,Child,CF))).
$rule(find_maxcf_child_list([_|Rest],MaxChild,CChild,CCF),
	find_maxcf_child_list(Rest,MaxChild,CChild,CCF)).

%%......................................................................
pop(_). % planning_base

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
$environment(Env),$write(current_env(Env)),$nl.

$eof.

%%======================================================================
%% for test

newcell(foo_base).
$new_cellvar(foo_base,current_node,[]).
push(foo_base).

$rule(condition(CF),$and(
	$is(X,irand(5)),
	member(X,[0,3,a,b,c,d,e]),
	$is(CF,frand(0.0,1.0)),
	!)).
$rule(condition(CF),$and(
	$is(X,irand(3)),
	member(X,[0,3,a,b,c,d,e]),
	$is(CF,frand(0.0,1.0)),
	!)).
$rule(condition(CF),$and(
	$is(X,irand(2)),
	member(X,[0,3,a,b,c,d,e]),
	$is(CF,frand(0.0,1.0)),
	!)).
$rule(condition(CF),$and(
	$is(CF,frand(0.0,1.0)),
	!)).


$rule(activate, $and(
	node(Node),
	$cv_put( foo_base , current_node , Node ,force) ,
%	$write(up(Node)),$nl,
	!)).
$rule(deactivate, $and(
	node(Node),
%	$write(down(Node)),$nl,
	!)).
	
pop(foo_base).

push(strategy).

define_node(foo, 100000,[],[foo1,foo2,foo3],0.3).
push(foo_base,foo).
push(foo).
pop(_).

define_node(foo1,1000,[sig,sig1],[foo11,foo12],0.3).
push(foo_base,foo1).
push(foo1).
pop(_).

define_node(foo2,1000,[sig,sig2],[foo21,foo22],0.3).
push(foo_base,foo2).
push(foo2).
pop(_).

define_node(foo3,1000,[sig,sig3],[foo31,foo32],0.3).
push(foo_base,foo3).
push(foo3).
pop(_).


define_node(foo11,1000,[sig,sig3],[foo111],0.3).
push(foo_base,foo11).
push(foo11).
pop(_).

define_node(foo12,1000,[sig,sig4],[foo121],0.3).
push(foo_base,foo12).
push(foo12).
pop(_).

define_node(foo21,1000,[sig,sig5],[foo211],0.3).
push(foo_base,foo21).
push(foo21).
pop(_).

define_node(foo22,1000,[sig,sig6],[foo221],0.3).
push(foo_base,foo22).
push(foo22).
pop(_).

define_node(foo31,1000,[sig,sig4],[foo311],0.3).
push(foo_base,foo31).
push(foo31).
pop(_).

define_node(foo32,1000,[sig,sig5],[foo321],0.3).
push(foo_base,foo32).
push(foo32).
pop(_).

define_node(foo111,1000,[sig,sig1],[],0.0).
push(foo_base,foo111).

define_node(foo121,1000,[sig,sig2],[],0.0).
push(foo_base,foo121).

define_node(foo211,1000,[sig,sig3],[],0.0).
push(foo_base,foo211).

define_node(foo221,1000,[sig,sig4],[],0.0).
push(foo_base,foo221).

define_node(foo311,1000,[sig,sig5],[],0.0).
push(foo_base,foo311).

define_node(foo321,1000,[sig,sig6],[],0.0).
push(foo_base,foo321).

$cv_put( planning_base , topnode ,  foo  ,force)  .

pop(_).

push(planning_base).

$rule(sigloop(Sig,Interval), $and(
	$repeat,
	$signal(Sig),
%	log(10,signal,Sig),
	$msleep(0,Interval),
	$fail)).
$rule(peekloop, $and(
	$repeat,
	$cv_get( foo_base , current_node , Node ,no,yes) ,
	active_tree(Tree),
	$write(Node),$write(Tree),$nl,
	$sleep(1),
	$fail,
	!)).

$rule(foo, $and(
	$fork(toploop,TopLoop),
	$fork(sigloop(sig,2140),Sig),
	$fork(sigloop(sig1,2150),Sig1),
	$fork(sigloop(sig2,2250),Sig2),
	$fork(sigloop(sig3,2350),Sig3),
	$fork(sigloop(sig4,2450),Sig4),
	$fork(sigloop(sig5,2550),Sig5),
	$fork(sigloop(sig6,2650),Sig6),
	$fork(peekloop,Peek),
	!)).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
$environment(Env),$write(current_env(Env)),$nl.


